Loading...
Searching...
No Matches
Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA > Class Template Reference
Iterative Solvers Template Library (ISTL) | Iterative Solvers Template Library (ISTL) » Iterative Solvers » Preconditioners

Sequential overlapping Schwarz preconditioner. More...

`#include <dune/istl/overlappingschwarz.hh>`

Inheritance diagram for Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >:

## Public Types

typedef M | matrix_type
| The type of the matrix to precondition.
typedef X | domain_type
| The domain type of the preconditioner.
typedef X | range_type
| The range type of the preconditioner.
typedef TM | Mode
| The mode (additive or multiplicative) of the Schwarz method.
typedef X::field_type | field_type
| The field type of the preconditioner.
typedef matrix_type::size_type | size_type
| The return type of the size method.
typedef TA | allocator
| The allocator to use.
typedef std::set< size_type, std::less< size_type >, typename std::allocator_traits< TA >::template rebind_alloc< size_type > > | subdomain_type
| The type for the subdomain to row index mapping.
typedef std::vector< subdomain_type, typename std::allocator_traits< TA >::template rebind_alloc< subdomain_type > > | subdomain_vector
| The vector type containing the subdomain to row index mapping.
typedef SLList< size_type, typename std::allocator_traits< TA >::template rebind_alloc< size_type > > | subdomain_list
| The type for the row to subdomain mapping.
typedef std::vector< subdomain_list, typename std::allocator_traits< TA >::template rebind_alloc< subdomain_list > > | rowtodomain_vector
| The vector type containing the row index to subdomain mapping.
typedef TD | slu
| The type for the subdomain solver in use.
typedef std::vector< slu, typename std::allocator_traits< TA >::template rebind_alloc< slu > > | slu_vector
| The vector type containing subdomain solvers.

## Public Member Functions

| SeqOverlappingSchwarz (const matrix_type &mat, const subdomain_vector &subDomains, field_type relaxationFactor=1, bool onTheFly_=true)
| Construct the overlapping Schwarz method.
| SeqOverlappingSchwarz (const matrix_type &mat, const rowtodomain_vector &rowToDomain, field_type relaxationFactor=1, bool onTheFly_=true)
void | pre (X &x, X &b) override
| Prepare the preconditioner.
void | apply (X &v, const X &d) override
| Apply the preconditioner.
void | post (X &x) override
| Postprocess the preconditioner.
template<bool forward>
void | apply (X &v, const X &d)
| Apply one step of the preconditioner to the system A(v)=d.
SolverCategory::Category | category () const override
| Category of the preconditioner (see SolverCategory::Category).

## Detailed Description

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>
class Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >

Sequential overlapping Schwarz preconditioner.

Template Parameters

  M | The matrix type.
  X | The range and domain type.
  TM | The Schwarz mode. Currently supported modes are AdditiveSchwarzMode, MultiplicativeSchwarzMode, and SymmetricMultiplicativeSchwarzMode. (Default values is AdditiveSchwarzMode)
  TD | The type of the local subdomain solver to be used.
  TA | The type of the allocator to use.

## Member Typedef Documentation

## allocator

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef TA Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::allocator

The allocator to use.

## domain_type

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef X Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::domain_type

The domain type of the preconditioner.

## field_type

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef X::field_type Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::field_type

The field type of the preconditioner.

## matrix_type

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef M Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::matrix_type

The type of the matrix to precondition.

## Mode

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef TM Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::Mode

The mode (additive or multiplicative) of the Schwarz method.

Either AdditiveSchwarzMode or MultiplicativeSchwarzMode

## range_type

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef X Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::range_type

The range type of the preconditioner.

## rowtodomain_vector

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef std::vector<subdomain_list, typename std::allocator_traits<TA>::template rebind_alloc<subdomain_list> > Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::rowtodomain_vector

The vector type containing the row index to subdomain mapping.

## size_type

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef matrix_type::size_type Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::size_type

The return type of the size method.

## slu

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef TD Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::slu

The type for the subdomain solver in use.

## slu_vector

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef std::vector<slu, typename std::allocator_traits<TA>::template rebind_alloc<slu> > Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::slu_vector

The vector type containing subdomain solvers.

## subdomain_list

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef SLList<size_type, typename std::allocator_traits<TA>::template rebind_alloc<size_type> > Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::subdomain_list

The type for the row to subdomain mapping.

## subdomain_type

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef std::set<size_type, std::less<size_type>, typename std::allocator_traits<TA>::template rebind_alloc<size_type> > Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::subdomain_type

The type for the subdomain to row index mapping.

## subdomain_vector

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

typedef std::vector<subdomain_type, typename std::allocator_traits<TA>::template rebind_alloc<subdomain_type> > Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::subdomain_vector

The vector type containing the subdomain to row index mapping.

## Member Function Documentation

## category()

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

SolverCategory::Category Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::category | ( |  | ) | const

inline override virtual

Category of the preconditioner (see SolverCategory::Category).

Implements Dune::Preconditioner< X, X >.

## post()

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

void Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::post | ( | X & | x | ) |

inline override virtual

Postprocess the preconditioner.

Clean up.

This method is called after the last apply call for the linear system to be solved. Memory may be deallocated safely here. x is the solution of the linear equation.

Parameters

  x | The right hand side of the equation.

Implements Dune::Preconditioner< X, X >.

## pre()

template<class M, class X, class TM = AdditiveSchwarzMode, class TD = ILU0SubdomainSolver<M,X,X>, class TA = std::allocator<X>>

void Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >::pre | ( | X & | x,
|  | X & | b )

inline override virtual

Prepare the preconditioner.

Prepare the preconditioner.

A solver solves a linear operator equation A(x)=b by applying one or several steps of the preconditioner. The method pre() is called before the first apply operation. b and x are right hand side and solution vector of the linear system respectively. It may. e.g., scale the system, allocate memory or compute a (I)LU decomposition. Note: The ILU decomposition could also be computed in the constructor or with a separate method of the derived method if several linear systems with the same matrix are to be solved.

Note
  if a preconditioner is copied (e.g. for a second thread) again the pre() method has to be called to ensure proper memory management.

X x(0.0);
Y b = ...; // rhs
Preconditioner<X,Y> prec(...);
prec.pre(x,b); // prepare the preconditioner
prec.apply(x,b); // can be called multiple times now...
prec.post(x); // cleanup internal state
Dune::Preconditioner
Base class for matrix free definition of preconditioners.
Definition preconditioner.hh:33

Parameters

  x | The left hand side of the equation.
  b | The right hand side of the equation.

Implements Dune::Preconditioner< X, X >.

The documentation for this class was generated from the following files:

- ldl.hh
- overlappingschwarz.hh